本文共 4249 字,大约阅读时间需要 14 分钟。
package SwordOffer;/*** @Description:地上有一个m行n列的方格,从坐标 [0,0] 到坐标 [m-1,n-1] 。一个机器人从坐标 [0, 0] 的格子开始移动,它每次可以向左、右、上、下移动一格(不能移动到方格外),也不能进入行坐标和列坐标的数位之和大于k的格子。例如,当k为18时,机器人能够进入方格 [35, 37] ,因为3+5+3+7=18。但它不能进入方格 [35, 38],因为3+5+3+8=19。请问该机器人能够到达多少个格子? 示例 1:输入:m = 2, n = 3, k = 1输出:3示例 2:输入:m = 3, n = 1, k = 0输出:1提示:1 <= n,m <= 1000 <= k <= 20来源:力扣(LeetCode)链接:https://leetcode-cn.com/problems/ji-qi-ren-de-yun-dong-fan-wei-lcof著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。* @Param:* @return:* @Author: lvhong* @Date:* @E-mail lvhong282@163.com*/public class lab13middle { //广度优先 //复杂度分析 //时间复杂度:O(mn),其中 m 为方格的行数,n 为方格的列数。考虑所有格子都能进入,那么搜索的时候一个格子最多会被访问的次数为常数,所以时间复杂度为 O(2mn)=O(mn)O(2mn)=O(mn)。 //空间复杂度:O(mn),其中 m 为方格的行数,n 为方格的列数。搜索的时候需要一个大小为 O(mn) 的标记结构用来标记每个格子是否被走过。 // //作者:LeetCode-Solution //链接:https://leetcode-cn.com/problems/ji-qi-ren-de-yun-dong-fan-wei-lcof/solution/ji-qi-ren-de-yun-dong-fan-wei-by-leetcode-solution/ //来源:力扣(LeetCode) //著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。// public int movingCount(int m, int n, int k) {// if (k == 0) {// return 1;// }// Queuequeue = new LinkedList ();// // 向右和向下的方向数组// int[] dx = {0, 1};// int[] dy = {1, 0};// boolean[][] vis = new boolean[m][n];// queue.offer(new int[]{0, 0});// vis[0][0] = true;// int ans = 1;// while (!queue.isEmpty()) {// int[] cell = queue.poll();// int x = cell[0], y = cell[1];// for (int i = 0; i < 2; ++i) {// int tx = dx[i] + x;// int ty = dy[i] + y;// if (tx < 0 || tx >= m || ty < 0 || ty >= n || vis[tx][ty] || get(tx) + get(ty) > k) {// continue;// }// queue.offer(new int[]{tx, ty});// vis[tx][ty] = true;// ans++;// }// }// return ans;// }//// private int get(int x) {// int res = 0;// while (x != 0) {// res += x % 10;// x /= 10;// }// return res;// }//递推//复杂度分析//时间复杂度:O(mn),其中 m 为方格的行数,n 为方格的列数。考虑所有格子都能进入,那么搜索的时候一个格子最多会被访问的次数为常数,所以时间复杂度为 O(2mn)=O(mn)O(2mn)=O(mn)。//空间复杂度:O(mn),其中 m 为方格的行数,n 为方格的列数。搜索的时候需要一个大小为 O(mn) 的标记结构用来标记每个格子是否被走过。////作者:LeetCode-Solution//链接:https://leetcode-cn.com/problems/ji-qi-ren-de-yun-dong-fan-wei-lcof/solution/ji-qi-ren-de-yun-dong-fan-wei-by-leetcode-solution///来源:力扣(LeetCode)//著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。// public int movingCount(int m, int n, int k) {// if (k == 0) {// return 1;// }// boolean[][] vis = new boolean[m][n];// int ans = 1;// vis[0][0] = true;// for (int i = 0; i < m; ++i) {// for (int j = 0; j < n; ++j) {// if ((i == 0 && j == 0) || get(i) + get(j) > k) {// continue;// }// // 边界判断// if (i - 1 >= 0) {// vis[i][j] |= vis[i - 1][j];// }// if (j - 1 >= 0) {// vis[i][j] |= vis[i][j - 1];// }// ans += vis[i][j] ? 1 : 0;// }// }// return ans;// }//// private int get(int x) {// int res = 0;// while (x != 0) {// res += x % 10;// x /= 10;// }// return res;// } //深度优先 //时间复杂度 O(MN)O(MN) : 最差情况下,机器人遍历矩阵所有单元格,此时时间复杂度为 O(MN)O(MN) 。 //空间复杂度 O(MN)O(MN) : 最差情况下,Set visited 内存储矩阵所有单元格的索引,使用 O(MN)O(MN) 的额外空间。 // //作者:jyd //链接:https://leetcode-cn.com/problems/ji-qi-ren-de-yun-dong-fan-wei-lcof/solution/mian-shi-ti-13-ji-qi-ren-de-yun-dong-fan-wei-dfs-b/ //来源:力扣(LeetCode) //著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。 int m, n, k; boolean[][] visited; public int movingCount(int m, int n, int k) { this.m = m; this.n = n; this.k = k; this.visited = new boolean[m][n]; return dfs(0, 0, 0, 0); } public int dfs(int i, int j, int si, int sj) { if(i >= m || j >= n || k < si + sj || visited[i][j]) return 0; visited[i][j] = true; return 1 + dfs(i + 1, j, (i + 1) % 10 != 0 ? si + 1 : si - 8, sj) + dfs(i, j + 1, si, (j + 1) % 10 != 0 ? sj + 1 : sj - 8); }}